SystemOrganization addCategory: #'OSC-Kernel'!
SystemOrganization addCategory: #'OSC-Tests'!

TestCase subclass: #OSCFloatTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCFloatTest methodsFor: 'tests' stamp: 'mga 6/28/2000 16:34'!
testPrintOnOSCStream
"
	self debug: #testPrintOnOSCStream
"
	|aByteArray aStream|
	aStream :=  (RWBinaryOrTextStream on: '') binary.
	aByteArray :=
		((RWBinaryOrTextStream on: '')
			binary;
			nextPut: 65;
			nextPut: 44;
			nextPut: 27;
			nextPut: 113;
			contents).
	10.7567 printOnOSCStream: aStream.
	self assert: ( aStream contents = aByteArray)! !

TestCase subclass: #OSCMessageTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCMessageTest methodsFor: 'tests' stamp: 'SimonHolland 9/21/2007 23:10'!
testByteArrayDecreaseVolume
	"
	self debug: #testByteArrayDecreaseVolume
	"
	|aByteArray|
	aByteArray:= #(47 115 99 47 109 105 120 101 114 47 118 111 108 117 109 101 0 0 0 0 
					44 105 102 0 0 0 0 1 62 76 204 205) asByteArray.
	self assert: (OSCMessage exampleSCDecreaseVolume byteArray = aByteArray)! !

!OSCMessageTest methodsFor: 'tests' stamp: 'mga 3/29/2005 21:27'!
testByteArrayIncreaseVolume
	"
	self debug: #testByteArrayIncreaseVolume
	"
	|aByteArray|
	aByteArray:= #(47 115 99 47 109 105 120 101 114 47 118 111 108 117 109 101 0 0 0 0 44
					105 102 0 0 0 0 1 63 128 0 0) asByteArray.
	self assert: (OSCMessage exampleSCIncreaseVolume byteArray = aByteArray)! !

!OSCMessageTest methodsFor: 'tests' stamp: 'mga 3/29/2005 21:27'!
testByteArrayRun
	"
	self debug: #testByteArrayRun
	"
	self assert: (OSCMessage exampleSCRun byteArray = ('/sc/run',(String with: (Character value: 0) with: $,)) asByteArray)! !

!OSCMessageTest methodsFor: 'tests' stamp: 'mga 3/29/2005 21:27'!
testByteArrayStop
	"
	self debug: #testByteArrayStop
	"
	self assert: (OSCMessage exampleSCStop byteArray = ('/sc/stop',((String new: 4 withAll: (Character value: 0)),',')) asByteArray)

! !

!OSCMessageTest methodsFor: 'tests' stamp: 'mga 3/29/2005 21:27'!
testExampleBerkeley2
	"See http://www.cnmat.berkeley.edu/OpenSoundControl/OSC-spec-examples.html"
	"
	self debug: #testExampleBerkeley2
	"
	|aByteArray|
	aByteArray:= #(
16r2F  16r66  16r6F 16r6F 
 0     0   0  0 
 16r2C   16r69   16r69  16r73
 16r66   16r66  0    0 
 0   0  3 16rE8 
 16rFF  16rFF  16rFF  16rFF 
16r68   16r65  16r6C  16r6C
 16r6F   0 0 0
16r3F 16r9D  16rF3  16rB6
 16r40  16rB5   16rB2  16r2D ) asByteArray.
	self assert: (OSCMessage exampleBerkeley2 byteArray = aByteArray)! !

TestCase subclass: #OSCParserTest
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCParserTest methodsFor: 'tests' stamp: 'Richo 1/18/2011 17:33'!
testParse
	"self debug: #testParse"
	 
	self assert: ((OSCParser parse: OSCMessage exampleSCIncreaseVolume byteStream reset) first = OSCMessage exampleSCIncreaseVolume)! !

!OSCParserTest methodsFor: 'tests' stamp: 'Richo 1/18/2011 17:33'!
testParseExampleBerkely3Message
	"self debug: #testParseExampleBerkely3Message"
	 
	self assert: ((OSCParser parse: OSCMessage exampleBerkeley3 byteStream reset) first = OSCMessage exampleBerkeley3)! !

!OSCParserTest methodsFor: 'tests' stamp: 'Richo 1/18/2011 17:33'!
testParseIncreaseVolumeMessage
	"self debug: #testParseIncreaseVolumeMessage"
	 
	self assert: ((OSCParser parse: OSCMessage exampleSCIncreaseVolume byteStream reset) first = OSCMessage exampleSCIncreaseVolume)! !

TestCase subclass: #OSCParserTest2
	instanceVariableNames: 'numberArray sampleDataStream messages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCParserTest2 commentStamp: 'SimonHolland 9/15/2007 11:54' prior: 0!
This should ideally be separated out into more & finer tests, but for the moment, this tests for at least two possible problems in one combined test.

(a) When several incoming messages arrive in a single bundle, or more than one bundle arrives at once, all messages need to be parsed. 

(b) Incoming OSC packets can eaily be in excess of 1024  bytes . OSCServer should be able to accomodate  this.!

!OSCParserTest2 methodsFor: 'accessing' stamp: 'SimonHolland 9/9/2007 00:25'!
numberArray
	^ numberArray! !

!OSCParserTest2 methodsFor: 'accessing' stamp: 'SimonHolland 9/9/2007 00:25'!
numberArray: anObject
	numberArray := anObject! !

!OSCParserTest2 methodsFor: 'accessing' stamp: 'SimonHolland 9/9/2007 00:25'!
sampleDataStream
	^ sampleDataStream! !

!OSCParserTest2 methodsFor: 'accessing' stamp: 'SimonHolland 9/9/2007 00:25'!
sampleDataStream: anObject
	sampleDataStream := anObject! !

!OSCParserTest2 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 00:26'!
sampleDataStreamFromArray: anArray
| data stream |
	data:= ByteArray newFrom: anArray.
	stream:= (RWBinaryOrTextStream on: (String new: 2048)) binary;yourself.
	data  do: [:each  | stream nextPut: each].
	stream reset.
	^ stream binary



	! !

!OSCParserTest2 methodsFor: 'setup' stamp: 'SimonHolland 9/15/2007 11:15'!
setUp
	self setUpNumberArray.
	self sampleDataStream: ( self sampleDataStreamFromArray: numberArray).
	messages :=  OSCParser parse: self sampleDataStream ascii .! !

!OSCParserTest2 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 00:22'!
setUpNumberArray
	numberArray := #(35 98 117 110 100 108 101 0 0 0 0 0 0 0 0 1 0 0 0 32 47 116 117 105 111 47 50 68 111 98 106 0 44 115 115 0 115 111 117 114 99 101 0 0 118 105 115 105 111 110 0 0 0 0 0 76 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 105 105 105 105 105 105 105 105 0 0 0 0 97 108 105 118 101 0 0 0 0 0 0 42 0 0 0 43 0 0 0 44 0 0 0 45 0 0 0 46 0 0 0 47 0 0 0 48 0 0 0 49 0 0 0 50 0 0 0 51 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 42 0 0 0 14 63 88 136 237 63 47 122 89 62 37 252 84 61 115 94 16 60 154 81 117 0 0 0 0 186 128 127 210 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 43 0 0 0 13 63 88 151 24 63 102 3 195 62 1 60 116 61 137 156 31 60 130 116 93 0 0 0 0 186 105 27 53 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 44 0 0 0 7 63 23 3 240 63 92 135 87 61 238 4 233 61 149 61 24 0 0 0 0 0 0 0 0 186 182 82 171 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 45 0 0 0 10 63 56 107 155 63 97 75 217 61 226 44 41 62 17 0 62 60 161 91 39 0 0 0 0 59 13 245 244 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 46 0 0 0 1 62 159 147 223 63 82 44 101 61 217 161 105 61 147 225 210 0 0 0 0 0 0 0 0 186 211 195 233 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 47 0 0 0 4 62 232 110 187 63 87 110 53 61 253 117 41 61 151 241 117 0 0 0 0 0 0 0 0 186 198 7 73 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 48 0 0 0 5 62 241 108 216 63 29 239 197 62 20 220 212 61 147 100 218 0 0 0 0 0 0 0 0 186 164 190 84 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 49 0 0 0 8 63 25 248 194 63 36 28 76 62 18 63 84 61 136 42 109 0 0 0 0 0 0 0 0 186 172 239 184 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 50 0 0 0 11 63 57 145 158 63 41 213 19 62 29 206 148 61 131 164 93 60 178 155 39 0 0 0 0 186 140 41 253 0 0 0 0 0 0 0 72 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 105 102 102 102 102 102 102 102 102 0 0 0 0 115 101 116 0 0 0 0 51 0 0 0 2 62 172 214 28 63 23 74 151 62 9 116 116 61 137 202 171 60 188 34 233 0 0 0 0 186 170 24 46 0 0 0 0 0 0 0 28 47 116 117 105 111 47 50 68 111 98 106 0 44 115 105 0 102 115 101 113 0 0 0 0 0 0 6 70).
! !

!OSCParserTest2 methodsFor: 'tests' stamp: 'Richo 1/18/2011 17:35'!
testParseAllInBundle
 self assert:  (messages first size = 13 ) .
 self assert:  ((messages first at: 2) second = 'alive') .
 self assert:  ((messages first at: 12) second = 'set') .
 self assert:  ((messages first at: 13) second = 'fseq') .

! !

!OSCParserTest2 methodsFor: 'testSuite' stamp: 'SimonHolland 9/15/2007 11:13'!
testSuite

| suite  |
suite := TestSuite named:'Parse the Full message'.
suite  addTest: (OSCParserTest2 selector: #testParseAllInBundle).		
^ suite



! !

TestCase subclass: #OSCParserTest3
	instanceVariableNames: 'string endingNumberArray startingNumberArray numberArrays streams parsedMessages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCParserTest3 commentStamp: 'SimonHolland 9/15/2007 11:55' prior: 0!
After the null that terminates a string, a well-formed incoming OSC message stream will have been padded with nulls if needed to reach a 32-bit word boundary, as per the OSC specification. This test checks that the parser handles this OK wherever the boundary may fall for a particular string in an incoming message.!

!OSCParserTest3 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 12:34'!
setUp
	self setUpString.
	self setUpStartingNumberArray.
	self setUpEndingNumberArray.
	self setUpNumberArrays.
	self setUpStreams.
	self setUpParsedMessages.! !

!OSCParserTest3 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 10:23'!
setUpEndingNumberArray
	endingNumberArray  := 
	string asArray  collect:  [ :each  |  each asInteger]  
	
! !

!OSCParserTest3 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 10:43'!
setUpNumberArrays
|  endArray |

numberArrays := Dictionary new.
(1 to: 4) keysAndValuesDo:
	 [:key :value |  endArray := endingNumberArray copyFrom: key  to: endingNumberArray size.
			   numberArrays  at: key put: (startingNumberArray , endArray) ].
	
	
! !

!OSCParserTest3 methodsFor: 'setup' stamp: 'SimonHolland 9/15/2007 11:17'!
setUpParsedMessages
	parsedMessages := Dictionary new.
	streams keysAndValuesDo: 
		[ :key :value |  parsedMessages  at: key put: ( OSCParser parse: value ascii) ].
		
		
! !

!OSCParserTest3 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 10:02'!
setUpStartingNumberArray
	| headerString typeMarker sizeOfPad nulls headerArray |
	headerString := 'Head'.
	typeMarker := ',s'.
	sizeOfPad :=  4 -  typeMarker size.
	nulls := Array new: sizeOfPad withAll: 0.
     headerArray :=  (headerString , typeMarker ) asArray.
	startingNumberArray  := (   headerArray , nulls  ) .
	! !

!OSCParserTest3 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 10:44'!
setUpStreams
	streams := Dictionary new.
	numberArrays keysAndValuesDo: [ :key :value |  streams at: key put: (self streamFromArray: value) ].
		
		
! !

!OSCParserTest3 methodsFor: 'setup' stamp: 'SimonHolland 9/9/2007 10:21'!
setUpString
	string  :=  'Reaktivision is  highly Groovy 0123456789' 
	
! !

!OSCParserTest3 methodsFor: 'converting' stamp: 'SimonHolland 9/9/2007 09:57'!
streamFromArray: anArray
| stream |
	stream:= (RWBinaryOrTextStream on: (String new: 2048)) binary;yourself.
	anArray  do: [:each  | stream nextPut: each asInteger].
	stream reset.
	^ stream binary



	! !

!OSCParserTest3 methodsFor: 'testSuite' stamp: 'SimonHolland 9/15/2007 11:13'!
testSuite

| suite  |
suite := TestSuite named:'ParseStringsUsingWordAlignment'.
suite  addTest: (OSCParserTest3 selector: #testWordAlignment).		
^ suite

		
! !

!OSCParserTest3 methodsFor: 'tests' stamp: 'SimonHolland 9/15/2007 11:19'!
testWordAlignment

parsedMessages  keysAndValuesDo: [ :key :value | 
		"Transcript cr; show:  ' Actual - ' , ((parsedMessages at:key) first second); cr.
		Transcript cr; show:  ' Should be - ', ( string copyFrom: key to: string size ); cr."
		 self assert:  ((parsedMessages at: key) first second ) =  ( string copyFrom: key to: string size )  ].



		
! !

TestCase subclass: #OSCServerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCServerTest methodsFor: 'tests' stamp: 'Richo 1/19/2011 11:02'!
testSendAndReceive
	| server |
	server := OSCServer listenOnPort: 5432.
	
	[OSCMessage example1 sendTo: NetNameResolver localHostAddress port: 5432.
	(Delay forDuration: (Duration milliSeconds: 30)) wait.
	self assert: server hasMessage.
	self assert: server nextMessage asArray = #('/example1' 100 )] 
			ensure: [server terminate]! !

!OSCServerTest methodsFor: 'tests' stamp: 'Richo 1/19/2011 11:08'!
testSendAndReceiveUsingEvents
	| server nextMessage |
	server := OSCServer listenOnPort: 5432.
	server when: #messageReceived evaluate: [:msg | nextMessage := msg].
	[OSCMessage example1 sendTo: NetNameResolver localHostAddress port: 5432.
	(Delay forDuration: (Duration milliSeconds: 30)) wait] 
			ensure: [server terminate].
	self assert: nextMessage asArray = #('/example1' 100 )! !

TestCase subclass: #OSCSmallIntegerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCSmallIntegerTest methodsFor: 'tests' stamp: 'mga 6/28/2000 16:34'!
testPrintOnOSCStream
"
	self debug: #testPrintOnOSCStream
"
	|aByteArray aStream|
	aStream :=  (RWBinaryOrTextStream on: '') binary.
	aByteArray :=
		((RWBinaryOrTextStream on: '')
			binary;
			nextPut: 0;
			nextPut: 0;
			nextPut: 4;
			nextPut: 100;
			contents).
	1124 printOnOSCStream: aStream.
	self assert: ( aStream contents = aByteArray)! !

TestCase subclass: #OSCStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Tests'!

!OSCStringTest methodsFor: 'tests' stamp: 'mga 3/28/2005 09:20'!
testPrintOnOSCStream
"
	self debug: #testPrintOnOSCStream
"
	|aString aStream|
	aStream :=  (RWBinaryOrTextStream on: '') binary.
	aString := 
		((WriteStream on: '')
			nextPutAll: 'abc';
			nextPut: (Character value: 0);
			contents).
	'abc' printOnOSCStream: aStream.
	self assert: ( aStream ascii contents = aString).
	aStream :=  (RWBinaryOrTextStream on: '') binary.
	aString := 
		((WriteStream on: '')
			nextPutAll: 'abcd';
			nextPutAll: (Array new: 4 withAll: (Character value: 0));
			contents).
	'abcd' printOnOSCStream: aStream.
	self assert: (aStream ascii contents = aString)! !

!SmallInteger methodsFor: '*OSC-printing' stamp: 'mga 3/2/2005 10:47'!
printOnOSCStream: aStream
	aStream nextInt32Put: self! !

!SmallInteger methodsFor: '*OSC-printing' stamp: 'mga 6/25/2000 10:12'!
printTypeOnOSCStream: aStream
	aStream nextPut: $i! !

!Float methodsFor: '*OSC-printing' stamp: 'mga 6/23/2000 15:43'!
printOnOSCStream:aStream
	aStream nextNumber: 4 put: self asIEEE32BitWord! !

!Float methodsFor: '*OSC-printing' stamp: 'mga 6/25/2000 11:10'!
printTypeOnOSCStream: aStream
	aStream nextPut: $f! !

!True methodsFor: '*OSC-printing' stamp: 'mga 6/27/2000 15:20'!
printTypeOnOSCStream: aStream
	aStream nextPut: $T! !

!UndefinedObject methodsFor: '*OSC-printing' stamp: 'mga 6/27/2000 15:19'!
printOnOSCStream: aStream
	^self! !

!UndefinedObject methodsFor: '*OSC-printing' stamp: 'mga 6/27/2000 15:18'!
printTypeOnOSCStream: aStream
	aStream nextPut: $N
! !

!False methodsFor: '*OSC-printing' stamp: 'mga 6/27/2000 15:21'!
printTypeOnOSCStream: aStream
	aStream nextPut: $F! !

!Symbol methodsFor: '*OSC-printing' stamp: 'mga 6/27/2000 15:23'!
printTypeOnOSCStream: aStream
	aStream nextPut: $s! !

SequenceableCollection subclass: #OSCPacket
	instanceVariableNames: 'collection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Kernel'!

!OSCPacket commentStamp: 'Richo 1/19/2011 13:31' prior: 0!
An OSCPacket is the abstract superclass representing the unit of transmission of OSC.
It is a subclass of SequenceableCollection allowing access to its contents using the usual collection protocol.
It also has some methods that permit sending this packet over the network (see "sending" category).

Instance Variables
	collection:		<Collection>

collection
	- The actual collection containing the packet's contents
!

OSCPacket subclass: #OSCBundle
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Kernel'!

!OSCBundle commentStamp: 'Richo 1/19/2011 13:44' prior: 0!
See class side for examples.

From The Open Sound Control 1.0 Specification:
--------------------------------------------------------------
"OSC Bundles
An OSC Bundle consists of the OSC-string "#bundle" followed by an OSC Time Tag, followed by zero or more OSC Bundle Elements. The OSC-timetag is a 64-bit fixed point time tag whose semantics are described below.

An OSC Bundle Element consists of its size and its contents. The size is an int32 representing the number of 8-bit bytes in the contents, and will always be a multiple of 4. The contents are either an OSC Message or an OSC Bundle.

Note this recursive definition: bundle may contain bundles."

Time tags are currently not supported.!

!OSCBundle class methodsFor: 'examples' stamp: 'mga 6/24/2000 14:07'!
example1
	^self for: {OSCMessage example1 .  OSCMessage example2}
	! !

!OSCBundle class methodsFor: 'examples' stamp: 'mga 6/24/2000 14:08'!
example2
	^self for: {OSCBundle example1 . OSCMessage example3}! !

!OSCBundle methodsFor: 'accessing' stamp: 'Richo 1/19/2011 13:37'!
eventSelector
	"Used by OSCServer to know which event trigger for this packet"
	^ #bundleReceived! !

!OSCBundle methodsFor: 'converting' stamp: 'Richo 1/19/2011 13:37'!
flattened
	"Converts the receiver into a flat array of OSCMessages"
	^ self inject: #() into: [:subTotal :next | subTotal , next flattened]! !

!OSCBundle methodsFor: 'printing' stamp: 'mga 6/24/2000 13:58'!
print: somePackets onOSCStream: aStream
	'#bundle' printOnOSCStream: aStream.
	self printTimeTagOnOSCStream: aStream.
	somePackets do: [:aPacket |
		aPacket oSCSize printOnOSCStream: aStream.
		aStream nextPutAll: aPacket byteArray]
	! !

!OSCBundle methodsFor: 'printing' stamp: 'mga 6/24/2000 13:25'!
printTimeTagOnOSCStream: aStream
	"Not yet implemented, just print 8 empty bytes"
	8 timesRepeat: [aStream nextPut: 0]! !

OSCPacket subclass: #OSCMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Kernel'!

!OSCMessage commentStamp: 'Richo 1/19/2011 13:42' prior: 0!
See class side for examples.

From The Open Sound Control 1.0 Specification:
--------------------------------------------------------------
"(...)
OSC Messages
An OSC message consists of an OSC Address Pattern followed by an OSC Type Tag String followed by zero or more OSC Arguments.

Note: some older implementations of OSC may omit the OSC Type Tag string. Until all such implementations are updated, OSC implementations should be robust in the case of a missing OSC Type Tag String.

OSC Address Patterns
An OSC Address Pattern is an OSC-string beginning with the character '/' (forward slash).

OSC Type Tag String
An OSC Type Tag String is an OSC-string beginning with the character ',' (comma) followed by a sequence of characters corresponding exactly to the sequence of OSC Arguments in the given message. Each character after the comma is called an OSC Type Tag and represents the type of the corresponding OSC Argument. (The requirement for OSC Type Tag Strings to start with a comma makes it easier for the recipient of an OSC Message to determine whether that OSC Message is lacking an OSC Type Tag String.)
(...)
OSC Arguments
A sequence of OSC Arguments is represented by a contiguous sequence of the binary representations of each argument."!

!OSCMessage class methodsFor: 'examples' stamp: 'mga 6/24/2000 14:18'!
example1
	^self for: {'/example1' . 100}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 6/24/2000 14:18'!
example2
	^self for: {'/example2' . 'tester' . 10.4}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 6/24/2000 14:19'!
example3
	^self for: {'/example3' . 20 . 30 . 'bla'}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:19'!
exampleBerkeley2
	^self for: self exampleBerkeley2Message! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:19'!
exampleBerkeley2Message
	^{'/foo' . 1000 . -1 . 'hello' . 1.234 . 5.678}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/30/2005 04:23'!
exampleBerkeley3
	^self for: self exampleBerkeley3Message! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/30/2005 04:23'!
exampleBerkeley3Message
	^{'/foo' . 1000 . -1 . 'hello' .1.125 . 4.0625 }! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:19'!
exampleSCA
	^self for: {'a' . 1 . 0.2}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:19'!
exampleSCDecreaseVolume
	^self for: {'/sc/mixer/volume' . 1 . 0.2}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:19'!
exampleSCIncreaseVolume
	^self for: self increaseVolumeMessage! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:19'!
exampleSCRun
	"self exampleSCRun sendTo: '10.0.1.2' port: 22"
	^self for: {'/sc/run'}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:20'!
exampleSCStop
	^self for: {'/sc/stop'}! !

!OSCMessage class methodsFor: 'examples' stamp: 'mga 3/29/2005 21:20'!
increaseVolumeMessage
	^{'/sc/mixer/volume' . 1 . 1.0}! !

!OSCMessage methodsFor: 'accessing' stamp: 'Richo 1/19/2011 13:37'!
eventSelector
	"Used by OSCServer to know which event trigger for this packet"
	^ #messageReceived! !

!OSCMessage methodsFor: 'converting' stamp: 'Richo 1/19/2011 13:37'!
flattened
	"Converts the receiver into a flat array of OSCMessages"
	^ {self}! !

!OSCMessage methodsFor: 'printing' stamp: 'mga 3/29/2005 21:37'!
print: someArguments onOSCStream: aStream

	| someParams |
	self printAddress: someArguments first onOSCStream: aStream.
	"Put the comma, also parameterless messages have one"
	aStream nextPut: 44.
	someParams := someArguments copyFrom: 2 to: someArguments size.
	self	
		printTypesOf: someParams on: aStream;
		printValues: someParams onOSCStream: aStream
! !

!OSCMessage methodsFor: 'printing' stamp: 'mga 6/27/2000 09:16'!
printAddress: anAddress onOSCStream: aStream
	anAddress printOnOSCStream: aStream
	
! !

!OSCMessage methodsFor: 'printing' stamp: 'mga 3/29/2005 21:37'!
printTypesOf: someValues on: aStream
	|aNullChar|	
	someValues isEmpty ifTrue: [^self].	
	aNullChar:= Character value: 0.
	someValues do: [:each | each printTypeOnOSCStream: aStream].
	(4 - (aStream position \\ 4)) timesRepeat: [aStream nextPut: aNullChar]
! !

!OSCMessage methodsFor: 'printing' stamp: 'mga 6/27/2000 09:27'!
printValues: someValues onOSCStream: aStream
	someValues do: [:each | each printOnOSCStream: aStream].
! !

!OSCPacket class methodsFor: 'instance creation' stamp: 'Richo 1/18/2011 13:17'!
for: somePackets
	^self on: somePackets ! !

!OSCPacket class methodsFor: 'instance creation' stamp: 'Richo 1/18/2011 13:17'!
new: sizeRequested
	^ self on: (Array new: sizeRequested)! !

!OSCPacket class methodsFor: 'instance creation' stamp: 'Richo 1/18/2011 13:17'!
newFrom: aCollection
	^ self on: aCollection ! !

!OSCPacket class methodsFor: 'instance creation' stamp: 'Richo 1/18/2011 13:17'!
on: aCollection
	^ (self basicNew setCollection: aCollection) initialize ! !

!OSCPacket methodsFor: 'collection protocol' stamp: 'Richo 1/18/2011 13:16'!
at: index
	^ collection at: index ! !

!OSCPacket methodsFor: 'collection protocol' stamp: 'Richo 1/18/2011 13:16'!
at: index put: value
	^ collection at: index put: value! !

!OSCPacket methodsFor: 'accessing' stamp: 'mga 3/28/2005 09:24'!
byteArray
	^self byteStream binary contents! !

!OSCPacket methodsFor: 'accessing' stamp: 'Richo 1/18/2011 13:20'!
byteStream
	| byteStream |
	byteStream := (RWBinaryOrTextStream on: '') yourself.
	self print: collection onOSCStream: byteStream.
	^ byteStream reset.! !

!OSCPacket methodsFor: 'accessing' stamp: 'Richo 1/19/2011 13:36'!
eventSelector
	"Used by OSCServer to know which event trigger for this packet"
	^ self subclassResponsibility! !

!OSCPacket methodsFor: 'converting' stamp: 'Richo 1/19/2011 13:37'!
flattened
	"Converts the receiver into a flat array of OSCMessages"
	^ self subclassResponsibility ! !

!OSCPacket methodsFor: 'accessing' stamp: 'mga 3/28/2005 07:56'!
oSCSize
	^self byteArray size! !

!OSCPacket methodsFor: 'printing' stamp: 'mga 6/24/2000 14:09'!
print: somePackets onOSCStream: aStream
	self subclassResponsibility! !

!OSCPacket methodsFor: 'sending' stamp: 'Richo 1/19/2011 18:16'!
sendTo: aByteArray port: aPort 
	"Take care, A byte array is not a string.
	If you want to send to e.g. '192.168.0.2' 
	sendToAddressString: port: instead
	But use this one if you want to be fast."
	| aSocket |
	Socket initializeNetwork.
	aSocket := Socket newUDP.
	aSocket
		sendUDPData: self byteArray
		toHost: aByteArray
		port: aPort;
		 close;
		 destroy! !

!OSCPacket methodsFor: 'sending' stamp: 'Richo 1/18/2011 13:33'!
sendToAddressString: anAddressString port: aPort 
	self 
		sendTo: (NetNameResolver addressForName: anAddressString)
		port: aPort! !

!OSCPacket methodsFor: 'sending' stamp: 'mga 9/17/2006 19:17'!
sendToYourself
	self sendTo: NetNameResolver localHostAddress port: 57123! !

!OSCPacket methodsFor: 'private' stamp: 'Richo 1/18/2011 13:17'!
setCollection: aCollection
	collection := aCollection ! !

!OSCPacket methodsFor: 'collection protocol' stamp: 'Richo 1/18/2011 13:16'!
size
	^ collection size! !

!SequenceableCollection methodsFor: '*OSC-printing' stamp: 'mga 6/27/2000 15:30'!
printOnOSCStream: aStream
	self do: [:each | each printOnOSCStream: aStream]! !

!SequenceableCollection methodsFor: '*OSC-printing' stamp: 'mga 6/27/2000 15:31'!
printTypeOnOSCStream: aStream
	aStream nextPut: $[.
	self do: [:each | each printTypeOnOSCStream: aStream].
	aStream nextPut: $]! !

!Boolean methodsFor: '*OSC-printing' stamp: 'mga 2/28/2005 17:16'!
printOnOSCStream: aStream
	^self! !

Object subclass: #OSCParser
	instanceVariableNames: 'byteStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Kernel'!

!OSCParser commentStamp: 'Richo 1/19/2011 13:32' prior: 0!
An OSCParser is responsible for parsing a stream of bytes and returning an array of OSCPackets. For example:

	(OSCParser parseArray: #[47 102 111 111 0 0 0 0 44 105 105 115 102 102 0 0 0 0 3 232 255 255 255 255 104 101 108 108 111 0 0 0 63 157 243 182 64 181 178 45]) explore.

Instance Variables
	byteStream:		<RWBinaryOrTextStream>

byteStream
	- The stream to parse.
!

!OSCParser class methodsFor: 'parse' stamp: 'Richo 1/18/2011 21:46'!
parse: aByteStream
	^ self parseStream: aByteStream ! !

!OSCParser class methodsFor: 'parse' stamp: 'Richo 1/19/2011 10:39'!
parseArray: aByteArray
	^ self parseStream: (RWBinaryOrTextStream with: aByteArray) reset! !

!OSCParser class methodsFor: 'parse' stamp: 'Richo 1/18/2011 21:46'!
parseStream: aByteStream
	^ (self basicNew initializeFor: aByteStream) parse! !

!OSCParser methodsFor: 'initialization' stamp: 'Richo 1/18/2011 16:59'!
initializeFor: aByteStream
	byteStream := aByteStream! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 21:46'!
parse
	^ Array streamContents: [:stream |
		[stream nextPut: self parsePacket] 
			doWhileFalse: [byteStream atEnd]]! !

!OSCParser methodsFor: 'parse' stamp: 'SimonHolland 9/15/2007 10:28'!
parseBlob
	^ nil! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/19/2011 15:12'!
parseBundle
	| packets |
	16 timesRepeat: [byteStream next]. "Ignore time stamp for now"
	packets := Array streamContents: [:stream |
		[byteStream atEnd]
			whileFalse: [| size | 
		size := self parseInt32.
		stream nextPutAll: (OSCParser parseArray: (byteStream next: size))]].
	^ OSCBundle on: packets! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 16:54'!
parseFloat
	^ Float fromIEEE32Bit: (byteStream binary nextNumber: 4)! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 16:39'!
parseHeader
	^ ((byteStream ascii upTo: $, ) copyWithout: (Character value: 0))
! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 16:54'!
parseInt32
	^ byteStream binary nextInt32! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 21:47'!
parseMessage
	| header values |
	header := self parseHeader.
	values := self parseTypes collect: [:type | self parseNextValueTyped: type].
	^ OSCMessage on: {header} , values! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 21:48'!
parseNextValueTyped: aType
	^ aType caseOf: {
		[$i] -> [self parseInt32].
		[$f] -> [self parseFloat].
		[$s] -> [self parseString].
		[$b] -> [self parseBlob]
	}! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 21:29'!
parsePacket
	^ byteStream ascii peek = $#
			ifTrue: [self parseBundle]
			ifFalse: [self parseMessage]! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 22:59'!
parseString
	| result |
	result := byteStream ascii upTo: (Character value: 0).
	4 - byteStream position \\ 4 timesRepeat: [byteStream next].
	^ result! !

!OSCParser methodsFor: 'parse' stamp: 'Richo 1/18/2011 21:53'!
parseTypes
	| next types |
	types := OrderedCollection new.
	[next := byteStream next.
	next = (Character value: 0) 
		ifTrue: [
			4 - byteStream position \\ 4 timesRepeat: [byteStream next].
			^types].
	('ifsb' includes: next) ifTrue: [types add: next]] repeat! !

Object subclass: #OSCServer
	instanceVariableNames: 'process socket packetQueue currentPacket'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OSC-Kernel'!

!OSCServer commentStamp: 'Richo 1/19/2011 13:49' prior: 0!
An OSCServer is responsible for listening for OSC packets on an UDP socket. After receiving a packet it raises an event to let users know a packet has arrived. It also stores the packet in a SharedQueue (for backwards compatibility).

Usage is very simple. Just create a new server like this:

	| server |
	server := OSCServer listenOnPort: 57123.

Then you can use #when:send:to: or #when:evaluate: to suscribe to either of the following events: #packetReceived, #messageReceived or #bundleReceived. Like this:

	server when: #packetReceived evaluate: [:packet | Transcript show: packet; cr].
	
As an alternative, you can also ask the server for the next message or packet. The following snippet does the same as above but polling instead of using events:

	process := [[server hasPacket ifTrue: [Transcript show: server nextPacket; cr]] repeat] fork.
	
Notice that in the last example we needed to create a new process constantly polling for new packets. To stop the process you should send #terminate.
	
	process terminate.
	
Finally, to stop the server you should also send #terminate.

	server terminate.

Instance Variables
	currentPacket:		<ReadStream>
	packetQueue:		<SharedQueue>
	process:		<Process>
	socket:		<Socket>

currentPacket
	- Here I store the current packet flattened in a stream, so that #nextMessage could work as it used to in OSC release 5.

packetQueue
	- I use this shared queue to store the packets as they arrive. It's almost equivalent to the old "messageQueue" from release 5.

process
	- The process that listens to the port.

socket
	- The udp socket used to receive the info from the network.
!

!OSCServer class methodsFor: 'as yet unclassified' stamp: 'mga 3/15/2005 23:45'!
listenOnPort: aPort
	"(self listenOnPort: 7010) inspect"
	^self new listenOnPort: aPort! !

!OSCServer methodsFor: 'accessing' stamp: 'Richo 1/19/2011 12:40'!
hasMessage
	^ currentPacket atEnd not or: [self hasPacket]! !

!OSCServer methodsFor: 'accessing' stamp: 'Richo 1/19/2011 10:44'!
hasPacket
	^ packetQueue isEmpty not! !

!OSCServer methodsFor: 'initialize-release' stamp: 'Richo 1/19/2011 12:40'!
initialize
	super initialize.
	packetQueue := SharedQueue new.
	currentPacket := ReadStream on: ''! !

!OSCServer methodsFor: 'action' stamp: 'Richo 1/19/2011 13:46'!
listenOnPort: aPort
	self terminate.
	socket := (Socket udpCreateIfFail: [self error: 'Problems connecting to: ', aPort asString]) setPort:  aPort.
	process := 
	[[| buf sizeOfBuf |
	buf := String new: 2048. 
	sizeOfBuf := socket receiveDataInto: buf.
	sizeOfBuf > 0 ifTrue: [| dataStream |
		dataStream := RWBinaryOrTextStream on: buf from: 1 to: sizeOfBuf.
		dataStream reset.
		self receive: dataStream]] repeat]  forkAt: Processor highIOPriority.
! !

!OSCServer methodsFor: 'accessing' stamp: 'Richo 1/19/2011 12:40'!
nextMessage
	currentPacket atEnd
		ifTrue: [currentPacket := packetQueue next flattened readStream].
	^ currentPacket next! !

!OSCServer methodsFor: 'accessing' stamp: 'Richo 1/19/2011 12:40'!
nextPacket
	currentPacket := ReadStream on: ''.
	^ packetQueue next! !

!OSCServer methodsFor: 'action' stamp: 'Richo 1/19/2011 10:44'!
receive: aByteStream 
	(OSCParser parse: aByteStream ascii)
		do: [:packet | 
			packetQueue nextPut: packet.
			self triggerEvent: #packetReceived with: packet;
				 triggerEvent: packet eventSelector with: packet].! !

!OSCServer methodsFor: 'initialize-release' stamp: 'mga 3/27/2005 22:49'!
terminate
	socket notNil ifTrue: [socket destroy].
	process notNil ifTrue: [process terminate]! !

!String methodsFor: '*OSC-printing' stamp: 'mga 3/16/2005 09:40'!
printOnOSCStream: aStream

	self isEmpty ifTrue: [^self].
	aStream nextPutAll: self asByteArray.
	(4 - (self size \\ 4)) timesRepeat: [aStream nextPut: 0]
! !

!String methodsFor: '*OSC-printing' stamp: 'mga 3/2/2005 10:49'!
printTypeOnOSCStream: aStream
	aStream nextPut: $s
! !
